diff --git a/tests/TestSuite_jumboframes.py b/tests/TestSuite_jumboframes.py
index 181908d2..e277bace 100644
--- a/tests/TestSuite_jumboframes.py
+++ b/tests/TestSuite_jumboframes.py
@@ -126,12 +126,6 @@ class TestJumboframes(TestCase):
 
         self.port_mask = utils.create_mask([self.rx_port, self.tx_port])
 
-        if self.kdriver == "fm10k":
-            netobj = self.dut.ports_info[self.tx_port]['port']
-            netobj.enable_jumbo(framesize = ETHER_JUMBO_FRAME_MTU)
-            netobj = self.dut.ports_info[self.rx_port]['port']
-            netobj.enable_jumbo(framesize = ETHER_JUMBO_FRAME_MTU)
-
         self.tester.send_expect("ifconfig %s mtu %s" % (self.tester.get_interface(self.tester.get_local_port(self.rx_port)), ETHER_JUMBO_FRAME_MTU + 200), "# ")
 
         self.pmdout = PmdOutput(self.dut)
@@ -162,10 +156,6 @@ class TestJumboframes(TestCase):
         This case aims to test transmitting jumbo frame packet on testpmd without
         jumbo frame support.
         """
-        # RRC has no ability to set the max pkt len to hardware
-        if self.kdriver == "fm10k":
-            print(utils.RED("fm10k not support this case\n"))
-            return
         self.pmdout.start_testpmd("Default", "--max-pkt-len=%d --port-topology=loop --tx-offloads=0x8000" % (ETHER_STANDARD_MTU))
         self.dut.send_expect("set fwd mac", "testpmd> ")
         self.dut.send_expect("start", "testpmd> ")
diff --git a/tests/TestSuite_pmdrss_hash.py b/tests/TestSuite_pmdrss_hash.py
index 54c0a89d..9ea6f9ae 100644
--- a/tests/TestSuite_pmdrss_hash.py
+++ b/tests/TestSuite_pmdrss_hash.py
@@ -414,8 +414,7 @@ class TestPmdrssHash(TestCase):
         """
 
         self.verify(self.nic in ["columbiaville_25g", "columbiaville_100g","fortville_eagle", "fortville_spirit",
-                    "fortville_spirit_single", "redrockcanyou", "atwood",
-                    "boulderrapid", "fortpark_TLV", "fortpark_BASE-T","fortville_25g", "niantic", "carlsville", "foxville"],
+                    "fortville_spirit_single", "fortpark_TLV", "fortpark_BASE-T","fortville_25g", "niantic", "carlsville", "foxville"],
                     "NIC Unsupported: " + str(self.nic))
         global reta_num
         global iptypes
@@ -436,13 +435,11 @@ class TestPmdrssHash(TestCase):
                        'ipv6-tcp': 'tcp',
                        'ipv6-frag': 'ip'
                        }
-        elif self.nic in ["redrockcanyou", "atwood", "boulderrapid"]:
-            reta_num = 128
         else:
             self.verify(False, "NIC Unsupported:%s" % str(self.nic))
         ports = self.dut.get_ports(self.nic)
         self.verify(len(ports) >= 1, "Not enough ports available")
-        self.path=self.dut.apps_name['test-pmd']
+        self.path = self.dut.apps_name['test-pmd']
 
     def set_up(self):
         """
@@ -543,10 +540,6 @@ class TestPmdrssHash(TestCase):
         global reta_num
         global iptypes
 
-        if self.kdriver in ["fm10k"]:
-            iptypes.pop('ipv4-sctp')
-            iptypes.pop('ipv6-sctp')
-
         self.dut.kill_all()
 
         # test with different rss queues
@@ -564,9 +557,8 @@ class TestPmdrssHash(TestCase):
 
             self.dut.send_expect("port stop all", "testpmd> ")
             # some nic not support change hash algorithm
-            if self.kdriver not in ["fm10k"]:
-                self.dut.send_expect(
-                    "set_hash_global_config 0 simple_xor %s enable" % iptype, "testpmd> ")
+            self.dut.send_expect(
+                "set_hash_global_config 0 simple_xor %s enable" % iptype, "testpmd> ")
             self.dut.send_expect("port start all", "testpmd> ")
             out = self.dut.send_expect(
                 "port config all rss %s" % rsstype, "testpmd> ")
diff --git a/tests/TestSuite_pmdrssreta.py b/tests/TestSuite_pmdrssreta.py
index 4dd3a5a5..ce3ee421 100644
--- a/tests/TestSuite_pmdrssreta.py
+++ b/tests/TestSuite_pmdrssreta.py
@@ -154,7 +154,7 @@ class TestPmdrssreta(TestCase):
                 hash_index = int(tmp_reta_line["RSS hash"], 16) % 64
             elif(self.nic in ["hi1822"]):
                 hash_index = int(tmp_reta_line["RSS hash"], 16) % 256
-            elif (self.nic in ["niantic", "redrockcanyou", "atwood", "boulderrapid", "foxville", "twinpond"]):
+            elif (self.nic in ["niantic", "foxville", "twinpond"]):
                 # compute the hash result of five tuple into the 7 LSBs value.
                 hash_index = int(tmp_reta_line["RSS hash"], 16) % 128
             else:
@@ -239,7 +239,7 @@ class TestPmdrssreta(TestCase):
                         reta_entries.insert(i, random.randint(0, queue - 1))
                         self.dut.send_expect(
                             "port config 0 rss reta (%d,%d)" % (i, reta_entries[i]), "testpmd> ")
-                elif (self.nic in ["niantic", "redrockcanyou", "atwood", "boulderrapid", "foxville"]):
+                elif (self.nic in ["niantic", "foxville"]):
                     for i in range(128):
                         reta_entries.insert(i, random.randint(0, queue - 1))
                         self.dut.send_expect(
@@ -255,7 +255,7 @@ class TestPmdrssreta(TestCase):
             self.dut.send_expect("quit", "# ", 30)
 
     def test_rss_key_size(self):
-        nic_rss_key_size = {"columbiaville_25g": 52, "columbiaville_100g": 52, "fortville_eagle": 52, "fortville_spirit": 52, "fortville_spirit_single": 52, "fortville_25g": 52, "niantic": 40, "e1000": 40, "redrockcanyou": 40, "atwood": 40,  "boulderrapid": 40, "fortpark_TLV": 52,"fortpark_BASE-T": 52, "hi1822": 40, "cavium_a063": 48, "cavium_a064": 48, "carlsville": 52, "sagepond": 40, "sageville": 40, "foxville": 40, "twinpond": 40}
+        nic_rss_key_size = {"columbiaville_25g": 52, "columbiaville_100g": 52, "fortville_eagle": 52, "fortville_spirit": 52, "fortville_spirit_single": 52, "fortville_25g": 52, "niantic": 40, "e1000": 40, "fortpark_TLV": 52,"fortpark_BASE-T": 52, "hi1822": 40, "cavium_a063": 48, "cavium_a064": 48, "carlsville": 52, "sagepond": 40, "sageville": 40, "foxville": 40, "twinpond": 40}
         self.verify(self.nic in list(nic_rss_key_size.keys()), "Not supporte rss key on %s" % self.nic)
 
         dutPorts = self.dut.get_ports(self.nic)
diff --git a/tests/TestSuite_rss_key_update.py b/tests/TestSuite_rss_key_update.py
index 4a9e3d83..f74641cb 100644
--- a/tests/TestSuite_rss_key_update.py
+++ b/tests/TestSuite_rss_key_update.py
@@ -171,8 +171,7 @@ class TestRssKeyUpdate(TestCase):
         """
 
         self.verify(self.nic in ["columbiaville_25g", "columbiaville_100g", "fortville_eagle", "fortville_spirit",
-                                 "fortville_spirit_single", "redrockcanyou", "atwood",
-                                 "boulderrapid", "fortpark_TLV", "fortpark_BASE-T", "fortville_25g", "niantic",
+                                 "fortville_spirit_single", "fortpark_TLV", "fortpark_BASE-T", "fortville_25g", "niantic",
                                  "carlsville", "foxville"],
                     "NIC Unsupported: " + str(self.nic))
         global reta_num
@@ -195,8 +194,6 @@ class TestRssKeyUpdate(TestCase):
                        'ipv6-tcp': 'tcp',
                        'ipv6-frag': 'ip'
                        }
-        elif self.nic in ["redrockcanyou", "atwood", "boulderrapid"]:
-            reta_num = 128
         else:
             self.verify(False, f"NIC Unsupported: {self.nic}")
 
@@ -301,13 +298,10 @@ class TestRssKeyUpdate(TestCase):
     def test_set_hash_key_short_long(self):
 
         nic_rss_key_size = {"columbiaville_25g": 52, "columbiaville_100g": 52, "fortville_eagle": 52,
-                            "fortville_spirit": 52,
-                            "fortville_spirit_single": 52, "fortville_25g": 52, "niantic": 40, "e1000": 40,
-                            "redrockcanyou": 40,
-                            "atwood": 40, "boulderrapid": 40, "fortpark_TLV": 52, "fortpark_BASE-T": 52, "hi1822": 40,
-                            "cavium_a063": 48,
-                            "cavium_a064": 48, "carlsville": 52, "sagepond": 40, "sageville": 40, "foxville": 40,
-                            "twinpond": 40}
+                            "fortville_spirit": 52, "fortville_spirit_single": 52, "fortville_25g": 52,
+                            "niantic": 40, "e1000": 40, "fortpark_TLV": 52, "fortpark_BASE-T": 52,
+                            "hi1822": 40, "cavium_a063": 48, "cavium_a064": 48, "carlsville": 52,
+                            "sagepond": 40, "sageville": 40, "foxville": 40, "twinpond": 40}
 
         self.verify(self.nic in list(nic_rss_key_size.keys()), f"Not supported rss key on {self.nic}")
 
diff --git a/tests/TestSuite_scatter.py b/tests/TestSuite_scatter.py
index 525ecfeb..2049f357 100644
--- a/tests/TestSuite_scatter.py
+++ b/tests/TestSuite_scatter.py
@@ -65,15 +65,12 @@ class TestScatter(TestCase):
         self.pmdout = PmdOutput(self.dut)
         if self.nic in ["magnolia_park", "niantic", "sageville", "fortpark", "fortville_eagle",
                         "fortville_spirit", "fortville_spirit_single", "fortville_25g", "x722_37d2",
-                        "redrockcanyou", "atwood", "boulderrapid",
-                        "ironpond", "twinpond", "springfountain", "fortpark_TLV","fortpark_BASE-T", "sagepond", "carlsville","columbiaville_25g","columbiaville_100g"]:
+                        "ironpond", "twinpond", "springfountain", "fortpark_TLV","fortpark_BASE-T",
+                        "sagepond", "carlsville","columbiaville_25g","columbiaville_100g"]:
             self.mbsize = 2048
         else:
             self.mbsize = 1024
 
-        if self.kdriver == "fm10k":
-            self.dut.ports_info[self.port]['port'].enable_jumbo(framesize=9000)
-
         self.tester.send_expect("ifconfig %s mtu 9000" % self.intf, "#")
 
     def scatter_pktgen_send_packet(self, pktsize):
@@ -130,7 +127,4 @@ class TestScatter(TestCase):
         """
         Run after each test suite.
         """
-        if self.kdriver == "fm10k":
-            self.dut.ports_info[self.port]['port'].enable_jumbo(framesize=1518)
         self.tester.send_expect("ifconfig %s mtu 1500" % self.intf, "#")
-        pass
diff --git a/tests/TestSuite_shutdown_api.py b/tests/TestSuite_shutdown_api.py
index 03eb89ab..3810b53a 100644
--- a/tests/TestSuite_shutdown_api.py
+++ b/tests/TestSuite_shutdown_api.py
@@ -157,21 +157,12 @@ class TestShutdownApi(TestCase):
         rx_bytes_exp = pktSize*4
         tx_bytes_exp = pktSize*4
 
-        if self.kdriver == "fm10k":
-            # RRC will always strip rx/tx crc
-            rx_bytes_exp -= 4
-            tx_bytes_exp -= 4
-            if vlan_strip is True:
-                # RRC will always strip rx/tx vlan
-                rx_bytes_exp -= 4
-                tx_bytes_exp -= 4
-        else:
-            # some NIC will always include tx crc
-            rx_bytes_exp -= 16
+        # The NIC will always include tx crc
+        rx_bytes_exp -= 16
+        tx_bytes_exp -= 16
+        if vlan_strip is True:
+            # vlan strip default is off
             tx_bytes_exp -= 16
-            if vlan_strip is True:
-                # vlan strip default is off
-                tx_bytes_exp -= 16
          
         # fortville nic enable send lldp packet function when port setup
         # now the tx-packets size is lldp_size(110) * n + forward packe size
@@ -188,10 +179,6 @@ class TestShutdownApi(TestCase):
         """
         Check link status of the ports.
         """
-        # RRC not support link speed change
-        if self.kdriver == "fm10k":
-            return
-
         for port in self.ports:
             out = self.tester.send_expect(
                 "ethtool %s" % self.tester.get_interface(self.tester.get_local_port(port)), "# ")
@@ -475,10 +462,6 @@ class TestShutdownApi(TestCase):
         """
         Change Link Speed.
         """
-        if self.kdriver == "fm10k":
-            print((utils.RED("RRC not support\n")))
-            return
-
         self.pmdout.start_testpmd("Default", "--portmask=%s --port-topology=loop" % utils.create_mask(self.ports), socket=self.ports_socket)
         self.dut.send_expect("set promisc all off", "testpmd>")
 
@@ -598,10 +581,6 @@ class TestShutdownApi(TestCase):
         """
         Enable/Disable Jumbo Frames.
         """
-        if self.kdriver == "fm10k":
-            print((utils.RED("RRC not support\n")))
-            return
-
         jumbo_size = 2048
         self.pmdout.start_testpmd("Default", "--portmask=%s --port-topology=loop" % utils.create_mask(self.ports), socket=self.ports_socket)
         self.dut.send_expect("set promisc all off", "testpmd>")
@@ -779,10 +758,6 @@ class TestShutdownApi(TestCase):
         """
         port link stats test
         """
-        if self.kdriver == "fm10k":
-            print((utils.RED("RRC not support\n")))
-            return
-
         self.pmdout.start_testpmd("Default", "--portmask=%s --port-topology=loop" % utils.create_mask(self.ports), socket=self.ports_socket)
         self.dut.send_expect("set promisc all off", "testpmd>")
         self.dut.send_expect("set fwd mac", "testpmd>")
diff --git a/tests/TestSuite_vf_offload.py b/tests/TestSuite_vf_offload.py
index b819c6c5..4a16134b 100644
--- a/tests/TestSuite_vf_offload.py
+++ b/tests/TestSuite_vf_offload.py
@@ -264,10 +264,6 @@ class TestVfOffload(TestCase):
                     'IPv6/UDP': 'Ether(dst="02:00:00:00:00:00", src="%s")/IPv6(src="%s")/UDP()/("X"*46)' % (mac, expIPv6),
                     'IPv6/TCP': 'Ether(dst="02:00:00:00:00:00", src="%s")/IPv6(src="%s")/TCP()/("X"*46)' % (mac, expIPv6)}
 
-        if self.nic in ['redrockcanyou', 'atwood']:
-            del pkts['IP/SCTP']
-            del pkts_ref['IP/SCTP']
-
         self.checksum_enablehw(0,self.vm_dut_0)
 
         self.vm0_testpmd.execute_cmd('start')
diff --git a/tests/TestSuite_vf_rss.py b/tests/TestSuite_vf_rss.py
index 35d4ea2e..4e48163b 100644
--- a/tests/TestSuite_vf_rss.py
+++ b/tests/TestSuite_vf_rss.py
@@ -204,10 +204,7 @@ class TestVfRss(TestCase):
         self.verify(len(reta_lines) > 0, "The testpmd output has no RSS hash!")
         for tmp_reta_line in reta_lines:
             status = "false"
-            if self.kdriver == "fm10k":
-                # compute the hash result of five tuple into the 7 LSBs value.
-                hash_index = int(tmp_reta_line["RSS hash"], 16) % 128
-            elif self.kdriver == 'i40e' or self.kdriver == 'ice' or self.nic in ['sageville', 'sagepond']:
+            if self.kdriver == 'i40e' or self.kdriver == 'ice' or self.nic in ['sageville', 'sagepond']:
                 # compute the hash result of five tuple into the 7 LSBs value.
                 hash_index = int(tmp_reta_line["RSS hash"], 16) % 64
             else:
@@ -233,9 +230,9 @@ class TestVfRss(TestCase):
         """
 
         self.verify(
-            self.nic in ["redrockcanyou", "atwood", "boulderrapid", "fortville_eagle", "fortville_spirit",
-                         "fortville_spirit_single", "fortville_25g", "sageville", "sagepond", "fortpark_TLV",
-                         "fortpark_BASE-T", "carlsville", "columbiaville_25g", "columbiaville_100g"],
+            self.nic in ["fortville_eagle", "fortville_spirit", "fortville_spirit_single", "fortville_25g",
+                         "sageville", "sagepond", "fortpark_TLV","fortpark_BASE-T", "carlsville",
+                         "columbiaville_25g", "columbiaville_100g"],
             "NIC Unsupported: " + str(self.nic))
         self.dut_ports = self.dut.get_ports(self.nic)
         self.verify(len(self.dut_ports) >= 1, "Not enough ports available")
@@ -358,13 +355,7 @@ class TestVfRss(TestCase):
                     "set nbcore %d" % (queue + 1), "testpmd> ")
 
                 # configure the reta with specific mappings.
-                if self.nic in ["redrockcanyou", "atwood", "boulderrapid"]:
-                    for i in range(128):
-                        reta_entries.insert(i, random.randint(0, queue - 1))
-                        self.vm_dut_0.send_expect(
-                            "port config 0 rss reta (%d,%d)" % (i, reta_entries[i]), "testpmd> ")
-                    self.vm_dut_0.send_expect("port config all rss %s" % rss_type, "testpmd> ")
-                elif self.kdriver == 'i40e' or self.kdriver == 'ice' or self.nic in ['sageville', 'sagepond']:
+                if self.kdriver == 'i40e' or self.kdriver == 'ice' or self.nic in ['sageville', 'sagepond']:
                     if self.nic in ['sageville', 'sagepond'] and rss_type == 'sctp':
                         self.logger.info('sageville and sagepond do not support rsstype sctp')
                         continue
diff --git a/tests/TestSuite_vlan.py b/tests/TestSuite_vlan.py
index 95e8cffa..c1c09ee0 100644
--- a/tests/TestSuite_vlan.py
+++ b/tests/TestSuite_vlan.py
@@ -79,10 +79,6 @@ class TestVlan(TestCase):
         self.dut.send_expect("vlan set strip off %s" % dutRxPortId, "testpmd> ")
         self.vlan = 51
 
-        if self.kdriver == "fm10k":
-            netobj = self.dut.ports_info[dutRxPortId]['port']
-            netobj.add_vlan(vlan_id = self.vlan)
-
     def get_tcpdump_package(self):
         pkts = self.tester.load_tcpdump_sniff_packets(self.inst)
         vlans = []
@@ -128,10 +124,6 @@ class TestVlan(TestCase):
         """
         Enable receipt of VLAN packets and strip off
         """
-
-        if self.kdriver == "fm10k":
-            print((utils.RED("fm10k not support this case\n")))
-            return
         self.dut.send_expect("rx_vlan add %d %s" % (self.vlan, dutRxPortId), "testpmd> ")
         self.dut.send_expect("vlan set strip off  %s" % dutRxPortId, "testpmd> ")
         self.dut.send_expect("start", "testpmd> ", 120)
@@ -183,11 +175,6 @@ class TestVlan(TestCase):
         """
         Enable VLAN header insertion in transmitted packets
         """
-        if self.kdriver == "fm10k":
-            netobj = self.dut.ports_info[dutTxPortId]['port']
-            netobj.add_vlan(vlan_id = self.vlan)
-            netobj.add_txvlan(vlan_id = self.vlan)
-
         self.dut.send_expect("stop", "testpmd> ")
         self.dut.send_expect("port stop all", "testpmd> ")
         self.dut.send_expect("tx_vlan set %s %d" % (dutTxPortId, self.vlan), "testpmd> ")
@@ -204,11 +191,6 @@ class TestVlan(TestCase):
         self.dut.send_expect("port start all", "testpmd> ")
         self.dut.send_expect("stop", "testpmd> ", 30)
 
-        if self.kdriver == "fm10k":
-            netobj = self.dut.ports_info[dutTxPortId]['port']
-            # not delete vlan for self.vlan will used later
-            netobj.delete_txvlan(vlan_id = self.vlan)
-
     def tear_down(self):
         """
         Run after each test case.
@@ -220,7 +202,3 @@ class TestVlan(TestCase):
         Run after each test suite.
         """
         self.dut.kill_all()
-        if self.kdriver == "fm10k":
-            netobj = self.dut.ports_info[dutRxPortId]['port']
-            netobj.delete_txvlan(vlan_id = self.vlan)
-            netobj.delete_vlan(vlan_id = self.vlan)
diff --git a/tests/TestSuite_vlan_ethertype_config.py b/tests/TestSuite_vlan_ethertype_config.py
index c31f585a..514bdd1f 100644
--- a/tests/TestSuite_vlan_ethertype_config.py
+++ b/tests/TestSuite_vlan_ethertype_config.py
@@ -165,9 +165,6 @@ class TestVlanEthertypeConfig(TestCase):
         """
         Test Case 1: change VLAN TPID
         """
-        if self.kdriver == "fm10k":
-            print((dts.RED("fm10k not support this case\n")))
-            return
         random_vlan = random.randint(1, MAX_VLAN - 1)
         self.dut.send_expect("set fwd rxonly", "testpmd> ")
         self.dut.send_expect("set verbose 1", "testpmd> ")
@@ -324,12 +321,6 @@ class TestVlanEthertypeConfig(TestCase):
                 vlan_string = str("%04x" % tpid) + str("%04x" % tx_vlan)
                 self.verify(vlan_string not in out, "Wrong vlan:" + str(out))
 
-        if self.kdriver == "fm10k":
-            for tx_vlan in tx_vlans:
-                netobj = self.dut.ports_info[dutTxPortId]['port']
-                # not delete vlan for self.vlan will used later
-                netobj.delete_txvlan(vlan_id=tx_vlan)
-
     def test_vlan_qinq_tpid(self):
         """
         Test Case 6: Change S-Tag and C-Tag within QinQ
@@ -377,7 +368,3 @@ class TestVlanEthertypeConfig(TestCase):
         Run after each test suite.
         """
         self.dut.kill_all()
-        if self.kdriver == "fm10k":
-            netobj = self.dut.ports_info[dutRxPortId]['port']
-            netobj.delete_txvlan(vlan_id=self.vlan)
-            netobj.delete_vlan(vlan_id=self.vlan)